import base64, os
import asyncio
import websockets
import json
import flask
from flask import send_file, make_response, render_template
import io

# app = flask.Flask(__name__)
app = flask.Flask(__name__, template_folder='template')
app.config["DEBUG"] = True

clientId = base64.b64encode(os.urandom(16))


# json = json.dumps(["admin","init",[0,3,2390], {"type": "hello"}, ["Long browser description","ShortBrowserDesc"],clientId.decode("utf-8"),True])

# msg = '{},["admin","init",[0,3,2390],["Long browser description","ShortBrowserDesc"],"{}",true]'.format(messageTag, clientId.decode("utf-8"))

def json_from_msg(msg):
    return json.loads(msg.split(",", 1)[1])

async def hello():
    uri = "ws://localhost:2020"
    async with websockets.connect(uri) as websocket:
        greeting = await websocket.recv()
        # print(f"< {greeting}")

        messageTag = "1515590796"
        _json = json.dumps({"command": "backend-connectWhatsApp", "type": "call", "from": "api2backend"})
        msg = '{},{}'.format(messageTag, _json)

        print("Connected, sending login message")
        await websocket.send(msg)
        # print(f"> {msg}")

        res = await websocket.recv()
        # print(f"< {res}")
        resource_id = json_from_msg(res)["resource_instance_id"]

        _json = json.dumps({"whatsapp_instance_id": resource_id, "command": "backend-generateQRCode",
         "type": "call", "from": "api2backend"})
        messageTag = "15155907961"
        msg = '{},{}'.format(messageTag, _json)

        print("requesting QR code")
        await websocket.send(msg)

        # receiving QR CODE
        res = await websocket.recv()
        _json = json_from_msg(res)
        qr_code_data = _json["image"]
        with open("qr_code", "w") as f:
            f.write(qr_code_data)



        i=0

        while True:
            res = await websocket.recv()
            # print("RECEIVED IN MYSOCKET.py: ")
            # print(res)
            # print()
            i+=1


asyncio.run(hello())


# asyncio.get_event_loop().run_until_complete(hello())